// -----JS CODE-----
// @input SceneObject binding
// @input SceneObject root
// @input SceneObject head

var bindingTransform = script.binding.getTransform();

var rootTransform = script.root.getTransform();
var rootOriginPosition = rootTransform.getWorldPosition();

var headTransform = script.head.getTransform();
var headOriginPosition = headTransform.getWorldPosition();
var headOriginRotation = headTransform.getWorldRotation();

var isLerping = false;
var isFaceFound = false;
var timeStartedLerping = 0;
var timeTakenDuringLerp = 0.25;
var startPosition;
var endPosition;
onFaceLost();

function onUpdate()
{
    if(isLerping)
    {
        var timeSinceStarted = getTime() - timeStartedLerping;
        var percentageComplete = timeSinceStarted / timeTakenDuringLerp;
        var des = vec3.lerp(startPosition, endPosition, percentageComplete);
        headTransform.setWorldPosition(des);
        if(percentageComplete >= 1.0)
        {
            isLerping = false;
        }
    }
    
    if(isFaceFound)
    {
        var bindingPos = bindingTransform.getWorldPosition();
        var pos = bindingPos.add(headOriginPosition);

        headTransform.setWorldPosition(pos);

        var bindingRot = bindingTransform.getWorldRotation();
        var rot = bindingRot.multiply(headOriginRotation);

        headTransform.setWorldRotation(rot);
    }
}

function onFaceFound()
{
    isFaceFound = true;
}

function onFaceLost()
{
    isFaceFound = false;
    backToOriginPos();
}

function backToOriginPos()
{
    isLerping = true;
    timeStartedLerping = getTime();
    startPosition = headTransform.getWorldPosition();
    endPosition = new vec3(-1,-6,-30);
}

var faceFoundEvent = script.createEvent("FaceFoundEvent");
faceFoundEvent.faceIndex = 0;
faceFoundEvent.bind(onFaceFound);

var faceLostEvent = script.createEvent("FaceLostEvent");
faceLostEvent.faceIndex = 0;
faceLostEvent.bind(onFaceLost);

var updateEvent = script.createEvent("UpdateEvent");
updateEvent.bind(onUpdate);